'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lezer = require('lezer');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const 
  EnvEndCommand = 1,
  MismatchedEnvEndCommand = 2,
  VerbatimContent = 3,
  VerbContent = 4,
  Environment = 16;

/* Hand-written tokenizers for TeX. */

const leftBrace = "{".charCodeAt(0);
const rightBrace = "}".charCodeAt(0);

function escapeRegex(string) {
  return string.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&");
}

const end = Array.from("\\end").map((c) => c.charCodeAt(0));

const envEnd = new lezer.ExternalTokenizer(
  (input, token, stack) => {
    let pos = token.start;
    let tokEnd = pos;
    for (let next, i = 0; (next = input.get(pos)); i++) {
      if (next !== end[i] && i < end.length) return;
      else if (i === end.length) break;
      else tokEnd = ++pos;
    }
    if (input.get(pos++) !== leftBrace) return;
    let nameStart = pos++;
    let nestLevel = 1;
    for (let next; (next = input.get(pos)) >= 0; ) {
      if (next === leftBrace) nestLevel++;
      if (next === rightBrace) nestLevel--;
      if (nestLevel === 0) break;
      pos++;
    }
    if (pos > nameStart + 1) {
      let name = input.read(nameStart, pos);
      let contextStart = stack.startOf([Environment]);
      if (contextStart >= 0) {
        if (
          !new RegExp(escapeRegex(name)).exec(
            input.read(contextStart, contextStart + name.length + 14)
          )
        ) {
          return token.accept(MismatchedEnvEndCommand, tokEnd);
        }
      }
    }
    token.accept(EnvEndCommand, tokEnd);
  },
  { contextual: true }
);

/* Hand-written tokenizers for TeX. */

const verbContent = new lezer.ExternalTokenizer(
  (input, token) => {
    const deliminator = input.get(token.start - 1);
    let pos = token.start;
    for (let next; (next = input.get(pos)) >= 0; pos++) {
      if (next === deliminator) return token.accept(VerbContent, pos);
    }
  },
  { contextual: true }
);

const endVerbatim = Array.from("\\end{verbatim").map((c) => c.charCodeAt(0));

const verbatimContent = new lezer.ExternalTokenizer(
  (input, token) => {
    let pos = token.start + 1;
    for (let i = 0, next; (next = input.get(pos)) >= 0; pos++) {
      maybe: if (next === endVerbatim[i]) {
        token.end = pos - 1;
        for (i++, pos++; i < endVerbatim.length; i++, pos++) {
          if (input.get(pos) !== endVerbatim[i]) {
            i = 0;
            break maybe;
          }
        }
        switch (input.get(pos)) {
          case "}".charCodeAt(0):
            return token.accept(VerbatimContent, token.end);
          case "*".charCodeAt(0):
            if (input.get(++pos) === "}".charCodeAt(0)) {
              return token.accept(VerbatimContent, token.end);
            }
        }
      }
    }
  },
  { contextual: true }
);

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_letters = {__proto__:null,csname:226, begin:232, textnormal:244, texttt:246, textmd:248, textbf:250, textup:252, textit:254, textsl:256, textsc:258, underline:260, mathbb:264, mathbf:266, mathcal:268, mathfrak:270, mathit:272, mathrm:274, mathscr:276, mathsf:278, mathtt:280, verb:282};
const spec_text = {__proto__:null,verbatim:238, "verbatim*":238};
const parser = lezer.Parser.deserialize({
  states: ":pOTPWOOOtPXO'#EdOOPP'#Ej'#EjO!wPWO'#CgOOPP'#Ep'#EpO#kPWO'#EpO$_PXO'#EsOOPP'#Cm'#CmO%UPYO'#EuOOPP'#Cu'#CuOOPP'#Cl'#ClO%YPWO'#C{O%^PWO'#DOO%bPWO'#DRO%fPWO'#DUO%jPWO'#DXO%nPWO'#D[O%rPWO'#D_O%vPWO'#DbO%zPWO'#DeOOPP'#Ey'#EyO&OPWO'#DhO&SPWO'#DkO&WPWO'#DnO&[PWO'#DqO&`PWO'#DtO&dPWO'#DwO&hPWO'#DzO&lPWO'#D}O&pPWO'#EQOOPP'#FT'#FTO&tP`O'#ETOOPP'#Ex'#ExO&xPWO'#E[O'`PWO'#E[O'vPWO'#E_O(^PWO'#E_OOPP'#F`'#F`OOPP'#Ei'#EiOOPP(3Bt(3BtQOPWOOO(tP`O'#CbOOPP,5:|,5:|OOPP'#Ci'#CiOOPP,59R,59RO*gPWO,59ROOPP,5;[,5;[O*kPWO,5;[O*oPWO'#CsOOPP,5;_,5;_O*sPXO,5;_O*zPXO,5;aO+RPWO,59gO+uPWO,59jO,iPWO,59mO-]PWO,59pO.PPWO,59sO.sPWO,59vO/gPWO,59yO0ZPWO,59|O0}PWO,5:PO1qPWO,5:SO2ePWO,5:VO3XPWO,5:YO3{PWO,5:]O4oPWO,5:`O5cPWO,5:cO6VPWO,5:fO6yPWO,5:iO7mPWO,5:lOOPS'#EV'#EVO8aP[O,5:oO8ePWO'#EeOOPO'#Fb'#FbOOPO(3Bu(3BuOOPO'#E]'#E]O9UPWO,5:vOOPO'#E^'#E^O9YPWO,5:vOOPO'#E`'#E`O9^PWO,5:yOOPO'#Ea'#EaO9bPWO,5:yOOPP,58|,58|OOPP,58},58}OOPP,59O,59OOOPP,59P,59POOPP,59Q,59QOOPO,59S,59SO9fPWO,59YOOPO,59h,59hOOPO,59k,59kOOPO,59n,59nOOPO,59q,59qOOPO,59t,59tOOPO,59w,59wOOPO,59z,59zOOPO,59},59}OOPO,5:Q,5:QOOPO,5:T,5:TOOPO,5:W,5:WOOPO,5:Z,5:ZOOPO,5:^,5:^OOPO,5:a,5:aOOPO,5:d,5:dOOPO,5:g,5:gOOPO,5:j,5:jOOPO,5:m,5:mOOPO,5:p,5:pOOPP1G.m1G.mOOPP1G0v1G0vO9jPWO,59_OOPP1G0y1G0yO:^PWO'#CyOOPP1G0{1G0{OOPO'#C}'#C}O:bPWO1G/ROOPO'#DQ'#DQO:fPWO1G/UOOPO'#DT'#DTO:jPWO1G/XOOPO'#DW'#DWO:nPWO1G/[OOPO'#DZ'#DZO:rPWO1G/_OOPO'#D^'#D^O:vPWO1G/bOOPO'#Da'#DaO:zPWO1G/eOOPO'#Dd'#DdO;OPWO1G/hOOPO'#Dg'#DgO;SPWO1G/kOOPO'#Dj'#DjO;WPWO1G/nOOPO'#Dm'#DmO;[PWO1G/qOOPO'#Dp'#DpO;`PWO1G/tOOPO'#Ds'#DsO;dPWO1G/wOOPO'#Dv'#DvO;hPWO1G/zOOPO'#Dy'#DyO;lPWO1G/}OOPO'#D|'#D|O;pPWO1G0QOOPO'#EP'#EPO;tPWO1G0TOOPO'#ES'#ESO;xPWO1G0WO;|P`O1G0ZOOPO,5:},5:}OOPP1G0b1G0bOOPP1G0e1G0eO<QPWO1G.tOOPO'#Ct'#CtO<wPWO1G.yO<{PWO,59eOOPP7+$m7+$mOOPP7+$p7+$pOOPP7+$s7+$sOOPP7+$v7+$vOOPP7+$y7+$yOOPP7+$|7+$|OOPP7+%P7+%POOPP7+%S7+%SOOPP7+%V7+%VOOPP7+%Y7+%YOOPP7+%]7+%]OOPP7+%`7+%`OOPP7+%c7+%cOOPP7+%f7+%fOOPP7+%i7+%iOOPP7+%l7+%lOOPP7+%o7+%oOOPP7+%r7+%rOOPP'#EW'#EWOOPP7+%u7+%uOOPO'#Co'#CoOOPO'#Cw'#CwO=PPWO7+$`O=TPWO7+$hOOPP7+$e7+$eOOPO'#Cz'#CzO=XPWO1G/PO=]PXO<<GzO>VPYO<<HSOOPP7+$k7+$kO>^PWOAN=fO?QPWOAN=nOOPO'#Cq'#CqO?tPWOG23QOOPO'#Cx'#CxO?xPWOG23YOOPPLD(lLD(lOOPQLD(tLD(t",
  stateData: "@Y~#[OS~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO#Y#WX#f#WX_#WXP#WXQ#WXf#WX~^TO!{vO!|vO!}vO#_yO#f{O#jvO$TqO$WrO$XsO$ZtO~^TO_!OO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO~P!QOQ!QO^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO~R!TO~^!UO~^!VO~^!WO~^!XO~^!YO~^!ZO~^![O~^!]O~^!^O~^!_O~^!`O~^!aO~^!bO~^!cO~^!dO~^!eO~^!fO~^!gO~#b!hO~^TO!{!kO!|!kO!}!kO#_yO#j!kO$V#PP~^TO!{!kO!|!kO!}!kO#_yO#j!kO$W#QP~^TO!{!kO!|!kO!}!kO#_yO#j!kO$Y#SP~^TO!{!kO!|!kO!}!kO#_yO#j!kO$Z#TP~#_!wO#`!uO#a!vO#b!xO#c!yO#e!zO#h!{O#n!|O#o!}O#p#OO#q#PO#r#QO#s#RO#t#SO#u#TO#v#UO#x#VO#y#WO#z#XO#{#YO#|#ZO#}#[O$O#]O$P#^O$Q#_O$R#`O~#f{O~_#bO~^#cO~P!QOQ!QO~P#eOQ#eO~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_qP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_tP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_wP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_zP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_}P~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!QP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!TP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!WP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!ZP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!^P~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!aP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!dP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!gP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!jP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!mP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!pP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!sP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_!vP~S$]O~^TO!{!kO!|!kO!}!kO#_yO#j!kO$V#XX$W#XX$Y#XX$Z#XX~$V$_O~$W$_O~$Y$`O~$Z$`O~^$aO~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtO_hP~^$dO~_$eO~_$fO~_$gO~_$hO~_$iO~_$jO~_$kO~_$lO~_$mO~_$nO~_$oO~_$pO~_$qO~_$rO~_$sO~_$tO~_$uO~_$vO~#b$wO~^TO!{vO!|vO!}vO#_yO#jvO#k$zO$TqO$WrO$XsO$ZtO_cP~_$}O~#k%OO~_%QO~_%RO~_%SO~d%TOPbyQby^by!{by!|by!}by#_by#jby$Tby$Wby$Xby$Zby~d%UORjy~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtOfeP~^TO!{vO!|vO!}vO#_yO#jvO$TqO$WrO$XsO$ZtOflP~f%ZO~f%[O~#c$Z#a^_!|#b#jdf!{~",
  goto: "B]$VPPPPPP$W$W$W$W$W$z%n&bPP&h'^(Q(tP(wP(z)Q'^)T)w)z)}*Q*T*w+k*T+n,b*T,e-X*T-[.O*T.R.u*T.x/l*T/o0c*T0f1Y*T1]2P2S2v3j2S3m4a2S4d5W2S5Z5}2S6Q6t2S6w7k2S7n8b2S8e9X2S9[:O:R:u;i;lPPP;o<^<a;o<d<g<j=Z=d?UPPP?b&hPPPPP&hPP@PP@sPP&h:RPPPPPPPPP:RPPPPPPPPPPAgPBU!cQOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!cSOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!cROPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UQ|RR#a}!WvOPRTU!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g#c$a%T%UZ!kqrst!j!cYOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!cUOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR${$aR%W%TQ!RUR#d!SR$c#c!cWOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$|$aR%Y%UR#f!TR%P$d!cdOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!cZOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#h!U!c[OPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#j!V!c]OPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#l!W!c^OPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#n!X!c_OPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#p!Y!c`OPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#r!Z!caOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#t![!cbOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#v!]!ccOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#x!^!cnOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!ceOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#z!_!cfOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR#|!`!cgOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$O!a!chOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$Q!b!ciOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$S!c!cjOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$U!d!ckOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$W!e!clOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$Y!f!cmOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR$[!g!cpOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!coOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%UR!ioR$x$]!XuOPRTU!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g#c$a%T%UR!nqR!prR!rsR!tt!UPORTU!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g#c$a%T%URzPW!jqrstR$^!jQxOQ}RQ!PTQ!SUQ#g!UQ#i!VQ#k!WQ#m!XQ#o!YQ#q!ZQ#s![Q#u!]Q#w!^Q#y!_Q#{!`Q#}!aQ$P!bQ$R!cQ$T!dQ$V!eQ$X!fQ$Z!gQ$b#cQ$y$aQ%V%TR%X%UQ!mqQ!orQ!qsR!st!XwOPRTU!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g#c$a%T%U!cVOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!cXOPRTUqrst!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g!j#c$a%T%U!XvOPRTU!U!V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!f!g#c$a%T%UZ!lqrst!j",
  nodeNames: "⚠ EnvEndCommand MismatchedEnvEndCommand VerbatimContent VerbContent Document ControlWord ControlSpace ControlLine ControlSymbol ControlNumber ControlSequenceName CommandName CommandName { } Environment GenericEnvironment BeginEnvironment EnvironmentName [ EnvironmentOption ] EndEnvironment EnvironmentName VerbatimEnvironment BeginEnvironment EnvironmentName EnvironmentOption EndEnvironment EnvironmentName textnormal CommandName Argument texttt CommandName Argument textmd CommandName Argument textbf CommandName Argument textup CommandName Argument textit CommandName Argument textsl CommandName Argument textsc CommandName Argument underline CommandName Argument mathbb CommandName Argument mathbf CommandName Argument mathcal CommandName Argument mathfrak CommandName Argument mathit CommandName Argument mathrm CommandName Argument mathscr CommandName Argument mathsf CommandName Argument mathtt CommandName Argument verb CommandName VerbLeftDelim VerbRightDelim ReservedCharacter Parameter Comment MathBlock MathContent MathContent MathLine MathContent MathContent",
  maxTerm: 149,
  nodeProps: [
    [lezer.NodeProp.top, 5,true],
    [lezer.NodeProp.closedBy, 18,"EndEnvironment",26,"EndEnvironment",87,"VerbRightDelim"],
    [lezer.NodeProp.openedBy, 23,"BeginEnvironment",29,"BeginEnvironment",88,"VerbLeftDelim"],
    [lezer.NodeProp.skipped, 91,true]
  ],
  repeatNodeCount: 2,
  tokenData: "1U~R|OX#{XY$}YZ$}Z](s]^$}^p#{pq$}qs#{st*ntu+Quv+cvw+}w!Q#{!Q![,U![!c#{!c!},q!}#O-e#O#P.Q#P#Q0V#Q#R+}#R#S+}#S#T#{#T#o,q#o#p0r#p#q#{#q#r0{#r#s+}#s#y#{#y#z(s#z$f#{$f$g(s$g#BY#{#BY#BZ(s#BZ$IS#{$IS$I_(s$I_$I|#{$I|$JO(s$JO$JT#{$JT$JU(s$JU$KV#{$KV$KW(s$KW&FU#{&FU&FV(s&FV~#{R$SU#bQ#jPOs$fw#O$f#P#Q$f#S#o$f#p#q$f#s~$fP$kU#jPOs$fw#O$f#P#Q$f#S#o$f#p#q$f#s~$f~%Yj#[~#aQ#bQ#jPOX$fX^&z^p$fpq&zqs$fw#O$f#P#Q$f#S#o$f#p#q$f#s#y$f#y#z&z#z$f$f$f$g&z$g#BY$f#BY#BZ&z#BZ$IS$f$IS$I_&z$I_$I|$f$I|$JO&z$JO$JT$f$JT$JU&z$JU$KV$f$KV$KW&z$KW&FU$f&FU&FV&z&FV~$f~'Rj#[~#jPOX$fX^&z^p$fpq&zqs$fw#O$f#P#Q$f#S#o$f#p#q$f#s#y$f#y#z&z#z$f$f$f$g&z$g#BY$f#BY#BZ&z#BZ$IS$f$IS$I_&z$I_$I|$f$I|$JO&z$JO$JT$f$JT$JU&z$JU$KV$f$KV$KW&z$KW&FU$f&FU&FV&z&FV~$f~(|j#[~#bQ#jPOX$fX^&z^p$fpq&zqs$fw#O$f#P#Q$f#S#o$f#p#q$f#s#y$f#y#z&z#z$f$f$f$g&z$g#BY$f#BY#BZ&z#BZ$IS$f$IS$I_&z$I_$I|$f$I|$JO&z$JO$JT$f$JT$JU&z$JU$KV$f$KV$KW&z$KW&FU$f&FU&FV&z&FV~$fR*uP#bQ!{P!Q![*xP*}P!|P!Q![*xR+ZP$ZP#bQ!{Ptu+^P+cO$WP~+lQ!}~#bQ!{POY+rZ~+r~+wQ!}~OY+rZ~+rR,UO#bQ!{PR,_U#cQ#bQ#jPOs$fw#O$f#P#Q$f#S#o$f#p#q$f#s~$fR,xX#`Q#jPOs$fw!c$f!c!},q!}#O$f#P#Q$f#S#T$f#T#o,q#p#q$f#s~$fR-nU#bQ#jPdPOs$fw#O$f#P#Q$f#S#o$f#p#q$f#s~$f~.ZT#_~#bQ!{Pxy.jyz.o!}#O.t#P#Q.y#X#Y/OP.oO$XPP.tO$YPP.yO$TPP/OO$VPP/RP#b#c/UP/XP#W#X/[P/_P#V#W/bP/eP#g#h/hP/kP#b#c/nP/qP#T#U/tP/wP#a#b/zP/}P#X#Y0QP0VO#fPR0`U#bQ#jPfPOs$fw#O$f#P#Q$f#S#o$f#p#q$f#s~$fR0{O^P#bQ!{PR1UO_P#bQ!{P",
  tokenizers: [envEnd, verbatimContent, verbContent, 0, 1],
  topRules: {"Document":[0,5]},
  specialized: [{term: 108, get: value => spec_letters[value] || -1},{term: 118, get: value => spec_text[value] || -1}],
  tokenPrec: 1424
});

exports.parser = parser;
